/****************************************************************************
  FileName     [ cirGate.cpp ]
  PackageName  [ cir ]
  Synopsis     [ Define class CirAigGate member functions ]
  Author       [ Chung-Yang (Ric) Huang ]
  Copyright    [ Copyleft(c) 2008-2012 LaDs(III), GIEE, NTU, Taiwan ]
****************************************************************************/

#include <iostream>
#include <iomanip>
#include <sstream>
#include <stdarg.h>
#include <cassert>
#include "cirGate.h"
#include "cirMgr.h"
#include "util.h"

using namespace std;

unsigned CirGate::_globalRef = 0;

extern CirMgr *cirMgr;

/**************************************/
/*   class CirGate member functions   */
/**************************************/
void
CirGate::reportGate() const
{
	cout<<"=================================================="<<endl;
	printGate();
	cout<<"= Value: ";
	unsigned bit;
	for(unsigned i=0; i<32; ++i)
	{
		bit = _sim >> (31-i);
		bit &= 1;
		cout<<bit;
		if(i==3 || i==7 || i==11 || i==15 || i==19 || i==23 || i==27)
			cout<<"_";
	}
	cout<<" ="<<endl;
	cout<<"=================================================="<<endl;
}

/*void
CirGate::reportFanin(int level) const
{
   assert (level >= 0);
}*/

void
CirGate::reportFanout(int level, int count, bool inv) const
{
   assert (level >= 0);
	if(count == 0) setGlobal();
	for(int i=0; i<2*count; ++i) cout<<" ";
	if(inv) cout<<"!";
	cout<<getTypeStr()<<" "<<ID;
	if(level > 0 && ismarked()) cout<<" (*)";
	cout<<endl;
	if(level > 0 && !ismarked())
	{
		setmark();
		int id;
		for(size_t s=0; s<_fanout.size(); ++s)
		{
			if(_fanout[s]->getTypeStr() == "AIG")
			{
				inv = !(_fanout[s]->getfinID(id));
				if(id != ID)
					inv = !(_fanout[s]->getfinID2(id));
				_fanout[s]->reportFanout(level-1, count+1, inv);
			}
			else
			{
				if(!_fanout[s]->getfinID(id)) inv = 1;
				else inv = 0;
				_fanout[s]->reportFanout(level-1, count+1, inv);
			}
		}
	}
}

void
CirGate::setFanout(CirGate* fout)
{
	//bool t = true;
	/*for(size_t i=0; i<_fanout.size(); ++i)
	{
		if(_fanout[i] == fout) t = false;
	}*/
	/*if(t)*/ _fanout.push_back(fout);
}

void
CirGate::erasefout(CirGate* fout)
{
	size_t j = _fanout.size();
	for(size_t i=0; i<_fanout.size(); ++i)
	{
		if(_fanout[i] == fout)
		{
			j = i;
			break;
		}
	}
	for(size_t i = j; i<_fanout.size()-1; ++i)
		_fanout[i] = _fanout[i+1];
	if(j != _fanout.size())
		_fanout.pop_back();
}

